org.apache.solr.client.solrj.cloud.autoscaling

## Interface Variable

All Known Implementing Classes:
  CoresVariable, FreeDiskVariable, NodeVariable, Variable.Type, VariableBase, VariableBase.CoreIndexSizeVariable, VariableBase.DiskTypeVariable, VariableBase.LazyVariable, VariableBase.TotalDiskVariable, WithCollectionVariable

Deprecated.
to be removed in Solr 9.0 (see SOLR-14656)

    public interface Variable

A Variable Type used in Autoscaling policy rules. Each variable type may have unique implementation of functionalities

### Nested Class Summary

Nested Classes
`static interface` `Variable.Meta` Deprecated.
`static class` `Variable.Type` Deprecated. Type details of each variable in policies

### Field Summary

Fields
`static String` `coreidxsize` Deprecated.
`static String` `NULL` Deprecated.

### Method Summary

All Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
`default boolean` `addViolatingReplicas(org.apache.solr.client.solrj.cloud.autoscaling.Violation.Ctx ctx)` Deprecated.
`int` `compareViolation(Violation v1, Violation v2)` Deprecated.
`default void` `computeDeviation(Policy.Session session, double[] deviations, org.apache.solr.client.solrj.cloud.autoscaling.ReplicaCount replicaCount, SealedClause sealedClause)` Deprecated.
`default Object` `computeValue(Policy.Session session, Condition condition, String collection, String shard, String node)` Deprecated. When a non constant value is used in a variable, the actual value needs to be computed at the runtime
`default Object` `convertVal(Object val)` Deprecated.
`default Operand` `getOperand(Operand expected, Object strVal, ComputedType computedType)` Deprecated.
`void` `getSuggestions(org.apache.solr.client.solrj.cloud.autoscaling.Suggestion.Ctx ctx)` Deprecated.
`default boolean` `match(Object inputVal, Operand op, Object val, String name, Row row)` Deprecated.
`default String` `postValidate(Condition condition)` Deprecated.
`default void` `projectAddReplica(Cell cell, ReplicaInfo ri, Consumer<org.apache.solr.client.solrj.cloud.autoscaling.Row.OperationInfo> opCollector, boolean strictMode)` Deprecated.
`default void` `projectRemoveReplica(Cell cell, ReplicaInfo ri, Consumer<org.apache.solr.client.solrj.cloud.autoscaling.Row.OperationInfo> opCollector)` Deprecated.
`Object` `validate(String name, Object val, boolean isRuleVal)` Deprecated.

### Field Detail

#### NULL

    static final String NULL

Deprecated.

See Also:
  Constant Field Values

#### coreidxsize

    static final String coreidxsize

Deprecated.

See Also:
  Constant Field Values

### Method Detail

#### match

    default boolean match(Object inputVal,
                          Operand op,
                          Object val,
                          String name,
                          Row row)

Deprecated.

#### convertVal

    default Object convertVal(Object val)

Deprecated.

#### projectAddReplica

    default void projectAddReplica(Cell cell,
                                   ReplicaInfo ri,
                                   Consumer<org.apache.solr.client.solrj.cloud.autoscaling.Row.OperationInfo> opCollector,
                                   boolean strictMode)

Deprecated.

#### addViolatingReplicas

    default boolean addViolatingReplicas(org.apache.solr.client.solrj.cloud.autoscaling.Violation.Ctx ctx)

Deprecated.

#### getSuggestions

    void getSuggestions(org.apache.solr.client.solrj.cloud.autoscaling.Suggestion.Ctx ctx)

Deprecated.

#### computeValue

    default Object computeValue(Policy.Session session,
                                Condition condition,
                                String collection,
                                String shard,
                                String node)

Deprecated.
When a non constant value is used in a variable, the actual value needs to be computed at the runtime

#### computeDeviation

    default void computeDeviation(Policy.Session session,
                                  double[] deviations,
                                  org.apache.solr.client.solrj.cloud.autoscaling.ReplicaCount replicaCount,
                                  SealedClause sealedClause)

Deprecated.

#### compareViolation

    int compareViolation(Violation v1,
                         Violation v2)

Deprecated.

#### projectRemoveReplica

    default void projectRemoveReplica(Cell cell,
                                      ReplicaInfo ri,
                                      Consumer<org.apache.solr.client.solrj.cloud.autoscaling.Row.OperationInfo> opCollector)

Deprecated.

#### postValidate

    default String postValidate(Condition condition)

Deprecated.

#### getOperand

    default Operand getOperand(Operand expected,
                               Object strVal,
                               ComputedType computedType)

Deprecated.

#### validate

    Object validate(String name,
                    Object val,
                    boolean isRuleVal)

Deprecated.